"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupUfPath = void 0;
const tslib_1 = require("tslib");
const interactive_1 = require("../../../core/options/interactive");
const prompt_1 = require("../../../core/utils/prompt");
const validation_1 = require("../../../core/utils/validation");
const ufPath_constant_1 = require("./ufPath.constant");
const fs_1 = require("fs");
function setupUfPath(config) {
    var _a;
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        let ufPath = (_a = config === null || config === void 0 ? void 0 : config.collect) === null || _a === void 0 ? void 0 : _a.ufPath;
        if ((0, interactive_1.get)()) {
            ufPath = yield (0, prompt_1.promptParam)({
                message: ufPath_constant_1.PROMPT_COLLECT_UF_PATH,
                initial: ufPath || ufPath_constant_1.DEFAULT_COLLECT_UF_PATH,
                skip: !!ufPath
            });
        }
        const errors = (0, validation_1.applyValidations)(ufPath, [
            validation_1.VALIDATORS.required
        ]);
        if ((0, validation_1.hasError)(errors)) {
            throw new Error(ufPath_constant_1.ERROR_COLLECT_UF_PATH_REQUIRED);
        }
        // DX create directory if it does ot exist
        try {
            (0, fs_1.readdirSync)(ufPath);
        }
        catch (e) {
            (0, fs_1.mkdirSync)(ufPath);
        }
        return Object.assign(Object.assign({}, config), { collect: Object.assign(Object.assign({}, config === null || config === void 0 ? void 0 : config.collect), { ufPath }) });
    });
}
exports.setupUfPath = setupUfPath;
//# sourceMappingURL=ufPath.setup.js.map